# LHCb-flavoured Markdown → Beamer slides

Makefile and scripts for writing Beamer slides in Markdown (via pandoc).
Included are quality-of-life features for citing and including plots from LHCb publications.

## Dependencies

Core dependencies:

- pandoc
- make
- latexmk
- metropolis beamer theme
- graphviz

If you want to use automatic LHCb figures and citations:

- python3 with beautifulsoup4
- XRootD (specifically the `xrdcp` command)
- A valid KRB5 token, with membership of `lhcb-general`

For the `show` rule in the Makefile:

- impressive

### Running in a container

```
singularity exec -CB $PWD --pwd=$PWD docker://gitlab-registry.cern.ch/admorris/dotfiles-templates make
```

## Pandoc beamer

A nice guide to writing the slides in Markdown is [here](https://github.com/alexeygumirov/pandoc-beamer-how-to).

You can type a mix of Markdown and LaTeX: macros, inline maths and even whole blocks of LaTeX will work.
At worst, you can always include some external LaTeX with `\input`.

**NB:** to include a `.tex` file outside of a `{frame}` environment (*e.g.* a file called `body/extra_slides.tex` containing several beamer frames), use the `NOFRAME` header:

```
## NOFRAME
\input{body/extra_slides}
```

One thing to look out for is the amount of whitespace: sometimes inserting a blank line can fix mangled output.

Backtick code blocks are enabled, with language-specific syntax highlighting (via `lstlistings`) and the `solarized` colour theme.
Note that both inline code and code blocks denoted by backticks in the Markdown source will be rendered with a tiny font.
For inline code at the normal font size, I recommend using `\texttt{}` instead.

### Beamer style

The beamer theme is `metropolis` with a custom colour palette (based on `tango` colours).
The typeface used is PT Sans (CERN's official font), with LaTeX symbols also rendered in sans-serif for consistency.
By default, the LHCb logo is in the top-right corner of the slides, where the dark blue section matches the title banner.
The logo can be changed in `metadata.yml`.

### LaTeX preamble

The file `head/preamble.tex` can be altered if you wish, *e.g.* to add extra `\usepackage` statements.
It refers to files contained in `input/` and custom packages defined in `texmf/tex/latex/`.

### YAML config

The file `metadata.yml` configures many things, such as the author(s), their affiliation, the title of the talk etc.
See [Metadata variables](https://pandoc.org/MANUAL.html#metadata-variables) and [Variables for Beamer slides](https://pandoc.org/MANUAL.html#variables-for-beamer-slides) in the Pandoc User's Guide.
Also, some of the keys from [Variables for LaTeX](https://pandoc.org/MANUAL.html#variables-for-latex) will work, and you may also want to read [Variables set automatically](https://pandoc.org/MANUAL.html#variables-set-automatically) for extra possible adjustments.

**NB:** the `titlegraphic` key is not used in favour of it being defined in `head/title-graphic.tex`, which grants more flexibility.

### Modular markdown source

The Markdown source is modularised and split across the `body/` and `appendix/` directories.
Only `.md` files beginning with two numbers and an underscore (*i.e.* matching the glob expression `[0-9][0-9]_*.md`) will be included, where the numbers can be used to control the order they appear in.
The matching files in `body/` will appear in the main body of the slides, while `appendix/` is for "backup slides" that will appear at the end. If you do not want an appendix, remove the corresponding `include-after` key in `metadata.yml`.

## LHCb scripts and customisations

### LHCb symbols

A copy of `lhcb-symbols-def.tex` is included in the `head/` directory.

### Citations

The macro `\lbcite` (defined in `head/custom-symbols-def.tex`) takes an LHCb PAPER, CONF or DP number and looks for the corresponding reference in `refs/LHCb-X-Y-Z.tex`, which is itself generated by the Makefile and `scripts/get_reference.py`.
The citation comes from the corresponding LHCb publication page and tries to follow the Speakers Bureau rules for citations in talks.

For non-LHCb papers, there is `\paperdoi` where the first argument is the DOI of the paper, and the second is the displayed text for the reference, *e.g.* `\paperdoi{10.1007/JHEP10(2015)053}{JHEP 10 (2015) 053}`.
You can also use the `\arxiv` macro, which just takes the arXiv number, *e.g.* `\arxiv{1508.00788}`.

A merge request that integrates BibTeX would be appreciated.

### Figures

The Makefile will grep for filenames in the Markdown source matching the pattern `Directory_LHCb-X-Y-Z/*`, which is the same pattern found at the ends of the URLs for plots on the LHCb publication pages.
Any matching but missing local files will be obtained with `xrdcp` from the appropriate EOS folder.
This makes the inclusion of plots from published papers a real breeze:

1. Open the web page (*e.g.* [LHCb-PAPER-2015-028.html](https://lhcbproject.web.cern.ch/Publications/LHCbProjectPublic/LHCb-PAPER-2015-028.html))
2. Find the URL of the figure you want to put in your slides, and copy everything from `Directory_LHCb` onwards (*e.g.* `Directory_LHCb-PAPER-2015-028/Fig1.pdf`)
3. Paste the into the Markdown source, using the usual syntax for images (*e.g.* `![](Directory_LHCb-PAPER-2015-028/Fig1.pdf){width=50%}`)

## Graphviz figures

`.dot` files placed in `graphviz/src` will be compiled into `.pdf` files and be available under the `\graphicspath`.

e.g. create `graphviz/src/flowchart.dot` and add `![](flowchart)` to the Markdown source. A file called `graphviz/flowchart.pdf` will be automatically created.
